﻿;Hobeta
; Заголовок:
; +0, 8 байт - имя файла TR-DOS
; +8, 1 байт - тип файла (расширение) TR-DOS
; +9, 2 байта - параметр START файла
; +11, 2 байта - параметр LENGTH файла (длина в байтах)

; +13, 2 байта - размер файла в секторах!!!! важно

; +15, 2 байта - контрольная сумма предыдущих 15 байт (не самого файла!)

; Данные:
; Побайтная копия всех секторов файла
; Старший байт размера файла в секторах всегда должен быть равен 0.
; Алгоритм расчета контрольной суммы:
; CheckSum=0;
; For (i=0; i<=14; CheckSum = CheckSum + (header[i] * 257) + i, i++);

;SCL
; Заголовок:
; +0, 8 байт - сигнатура SINCLAIR
; +8, 1 байт - число файлов
;header_b:
;  db "SINCLAIR"
;  db 1; filez
;
; Данные:
; Заголовки файлов (14 байт из каталога без track/sec):
; Заголовок 1-го файла
; ;-1st
; ;    12345678t
;  db "ExistenZB"
;  dw basic_e-basic_b-4;start
;  dw basic_e-basic_b-4;length?
;  db sectors basic_b,scl_e

; Данные файлов:
; Кодовый блок 1-го файла
; Кодовый блок 2-го и последующих файлов (если есть)
; Последние 4 байта - контpольная сyмма (арифметическая сумма всех предыдущих байт)


Global hStdOutput.l=GetStdHandle_(#STD_OUTPUT_HANDLE)
Global hStdInput.l=GetStdHandle_(#STD_INPUT_HANDLE)
Global dBytesWritten.l=0

Procedure conmsg(szMsg.s)
  ;        szMsg.s="Error creating file "+outf
  If hStdOutput<>#INVALID_HANDLE_VALUE
    WriteConsole_(hStdOutput,@szMsg,Len(szMsg),@dBytesWritten,0);INVALID_HANDLE_VALUE
  Else
    MessageRequester("Info",szMsg,#PB_MessageRequester_Ok )
  EndIf
EndProcedure

Procedure scl_checksum(outf.s)
         If OpenFile(3,outf)
          ch.l=0
          While Not Eof(3)
            ch=ch+ReadAsciiCharacter(3)
          Wend
          WriteLong(3,ch)
          CloseFile(3)
        Else
;           szMsg.s="Error creating checksum for "+outf
           conmsg("Error creating checksum for "+outf)
;           WriteConsole_(hStdOutput,@szMsg,Len(szMsg),@dBytesWritten,0)
        EndIf
EndProcedure


Procedure cnew(inf.s)
  fs=FileSize(inf)
  If fs>0
    outf.s=Mid( inf,1,Len(inf)-Len(GetExtensionPart(inf)) )+"scl"
    
    If ReadFile(0,inf)
      If CreateFile(1,outf)
        WriteString(1,"SINCLAIR")
        WriteAsciiCharacter(1,1)

        hobc.u=0
        For i=0 To 12
          a.a=ReadAsciiCharacter(0)
          ;подсчитать контрольную сумму
          hobc=hobc+i+257*a
          WriteAsciiCharacter(1,a);ReadAsciiCharacter(0))
        Next i
        fsiz.u=ReadUnicodeCharacter(0)
        hobc=hobc+13+257*(fsiz&255)
        hobc=hobc+14+257*(fsiz>>8)
        WriteAsciiCharacter(1,fsiz>>8)
        fcs.u=ReadUnicodeCharacter(0);checksum нахуй
;          Debug fcs
;          Debug hobc
        
        If hobc<>fcs
          CloseFile(0)
          CloseFile(1)
          conmsg(inf+" is not Hobeta:bad checksum")
          DeleteFile(outf)
          End
        EndIf
        
        
        While Not Eof(0)
          WriteAsciiCharacter(1,ReadAsciiCharacter(0))
        Wend
        CloseFile(0)
        CloseFile(1)
        ;checksum
        scl_checksum(outf)

      Else
        ;Debug "Error creating file "+outf
        ;szMsg.s="Error creating file "+outf
        ;WriteConsole_(hStdOutput,@szMsg,Len(szMsg),@dBytesWritten,0)
        conmsg("Error creating file "+outf)
      EndIf
      
    Else
      ;    Debug "Error opening file "+inf
      ;szMsg.s="Error opening file "+inf
      ;WriteConsole_(hStdOutput,@szMsg,Len(szMsg),@dBytesWritten,0)
      conmsg("Error opening file "+inf)
    EndIf
    
  Else
    ;  Debug "file "+inf+" not found."
    ;szMsg.s="file "+inf+" not found."
    ;WriteConsole_(hStdOutput,@szMsg,Len(szMsg),@dBytesWritten,0)
    conmsg("file "+inf+" not found.")
  EndIf
EndProcedure

Procedure addtoscl(hob.s,scl.s)
  
  f1=FileSize(scl)
  f2=FileSize(hob)
  If f1>0
    If f2>0
      If ReadFile(0,scl)
        If ReadFile(1,hob)
          *m=AllocateMemory(f1+f2)
          ;читаем scl
          disp=0
          For i=1 To 9
            v.a=ReadAsciiCharacter(0)
            PokeA(*m+disp,v)
            disp+1
          Next i
          If v=0; Or v=256
            conmsg("Bad sector number:"+Str(v))
            FreeMemory(*m)
            CloseFile(0)
            CloseFile(1)
            End
          Else
            ;Debug PeekS(*m,8,#PB_Ascii)
            If PeekS(*m,8,#PB_Ascii)<>"SPECTRUM"
              conmsg("Bad Header for "+scl)
              FreeMemory(*m)
              CloseFile(0)
              CloseFile(1)
              End
            EndIf

            PokeA(*m+8,v+1);на 1 файл больше
            secs=0
            For i=1 To v;копирование заголовков
              For j=1 To 14
                a.a=ReadAsciiCharacter(0)
                PokeA(*m+disp,a)
                disp+1
              Next j
              secs+a
            Next i

            If secs*256+9+v*14+4<>f1;проверка на размер файла
              conmsg("wrong size "+Str(f1)+" for "+scl)
              FreeMemory(*m)
              CloseFile(0)
              CloseFile(1)
              End
            EndIf

            ;копирую данные из хобеты
            hobc.u=0
            For j=0 To 14
              a.a=ReadAsciiCharacter(1)
              ;подсчитать контрольную сумму
              hobc=hobc+j+257*a
              PokeA(*m+disp,a)
              disp+1
            Next j
            hs.u=PeekU(*m+disp-2)
            PokeA(*m+disp-2,hs>>8)
            disp-1

            hcs=ReadUnicodeCharacter(1); сама сумма
            If hobc<>hcs
              conmsg(hob+" is not Hobeta:bad checksum")
              FreeMemory(*m)
              CloseFile(0)
              CloseFile(1)
              End
            EndIf
;             Debug hobc
;             Debug hcs

            For i=1 To secs*256;+9+v*14 ;копия секторов из SCL
              a.a=ReadAsciiCharacter(0)
              PokeA(*m+disp,a)
              disp+1
            Next i


            While Not Eof(1);хобету туда же
              a.a=ReadAsciiCharacter(1)
              PokeA(*m+disp,a)
              disp+1
            Wend
            ;Debug disp
            CloseFile(1)
            CloseFile(0)
            CreateFile(0,scl)
            WriteData(0,*m,disp)
            CloseFile(0)
            ;дописать КС
            scl_checksum(scl)
          EndIf
          
        Else
          conmsg("Error reading "+hob)
        EndIf
      Else
        conmsg("Error reading "+scl)
      EndIf
      
    Else
;      Debug "Error reading "+hob
      conmsg("Error reading "+hob)
      End 
    EndIf
  Else
;    Debug "Error reading "+scl
    conmsg("Error reading "+scl)
    End 
  EndIf
  
EndProcedure

ccc=CountProgramParameters()

;Debug hStdOutput

Select ccc
  Case 0
    szMsg.s="usage: hob2scl hobeta.$t [filename.scl]"+Chr($0D)+Chr($0A)+"hobeta.$t converted to .scl file"+Chr($0D)+Chr($0A)+"hobeta.$t filename.scl add hobeta.$t to filename.scl"
    WriteConsole_(hStdOutput,@szMsg,Len(szMsg),@dBytesWritten,0)
    
  Case 1; hob2scl hobeta.$B
    If FileSize(ProgramParameter(0))>17
      cnew(ProgramParameter(0))
    Else
      conmsg(ProgramParameter(0)+" too small for Hobeta")
    EndIf
  Case 2; hob2scl hobeta.$B file.scl
    addtoscl( ProgramParameter(0),ProgramParameter(1) )
EndSelect

; IDE Options = PureBasic 5.30 (Windows - x86)
; ExecutableFormat = Console
; CursorPosition = 100
; FirstLine = 76
; Folding = -
; EnableUnicode
; EnableXP
; Executable = hob2scl.exe
; CommandLine = boot.$b